<?php

declare(strict_types=1);

/*
 * Chill is a software for social workers
 *
 * For the full copyright and license information, please view
 * the LICENSE file that was distributed with this source code.
 */

namespace Chill\TicketBundle\Entity;

use Chill\MainBundle\Doctrine\Model\TrackCreationInterface;
use Chill\MainBundle\Doctrine\Model\TrackCreationTrait;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Serializer\Annotation as Serializer;

/**
 * Represents the history of an emergency status associated with a ticket.
 *
 * This entity is used to track the changes in a ticket's emergency status over time.
 * Implements the TrackCreationInterface for tracking entity lifecycle creation.
 */
#[ORM\Entity]
#[ORM\Table(name: 'emergency_status_history', schema: 'chill_ticket')]
#[Serializer\DiscriminatorMap(typeProperty: 'type', mapping: ['ticket_emergency_status_history' => EmergencyStatusHistory::class])]
class EmergencyStatusHistory implements TrackCreationInterface
{
    use TrackCreationTrait;

    #[ORM\Id]
    #[ORM\Column(type: \Doctrine\DBAL\Types\Types::INTEGER, nullable: false)]
    #[ORM\GeneratedValue(strategy: 'AUTO')]
    #[Serializer\Groups(['read'])]
    private ?int $id = null;

    #[ORM\Column(type: \Doctrine\DBAL\Types\Types::DATETIME_IMMUTABLE, nullable: true, options: ['default' => null])]
    #[Serializer\Groups(['read'])]
    private ?\DateTimeImmutable $endDate = null;

    public function __construct(
        #[ORM\Column(type: \Doctrine\DBAL\Types\Types::STRING, nullable: false, enumType: EmergencyStatusEnum::class)]
        #[Serializer\Groups(['read'])]
        private EmergencyStatusEnum $emergencyStatus,
        #[ORM\ManyToOne(targetEntity: Ticket::class)]
        #[ORM\JoinColumn(nullable: false)]
        private Ticket $ticket,
        #[ORM\Column(type: \Doctrine\DBAL\Types\Types::DATETIME_IMMUTABLE, nullable: false)]
        #[Serializer\Groups(['read'])]
        private \DateTimeImmutable $startDate = new \DateTimeImmutable('now'),
    ) {
        $ticket->addEmergencyStatusHistory($this);
    }

    public function getEndDate(): ?\DateTimeImmutable
    {
        return $this->endDate;
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getEmergencyStatus(): EmergencyStatusEnum
    {
        return $this->emergencyStatus;
    }

    public function getStartDate(): \DateTimeImmutable
    {
        return $this->startDate;
    }

    public function getTicket(): Ticket
    {
        return $this->ticket;
    }

    public function setEndDate(?\DateTimeImmutable $endDate): void
    {
        $this->endDate = $endDate;
    }
}
